#undef DEBUG

#if !defined(__E32BASE_H__)
#include <E32BASE.H>
#endif

#if !defined(__W32STD_H__)
#include <W32STD.H>
#endif

#if !defined(__FRMTLAY_H__)
#include <FRMTLAY.H>
#endif

#if !defined(__COEMAIN_H__)
#include <COEMAIN.H>
#endif

#if !defined(__COECNTRL_H__)
#include <COECNTRL.H>
#endif

#if !defined(__FEPBASE_H__)
#include <FEPBASE.H>
#endif

#if !defined(__FEPITFR_H__)
#include <FEPITFR.H>
#endif

#if !defined(__EIKDIALG_H__)
#include <EIKDIALG.H>
#endif

#if !defined(__AKNLISTS_H__)
#include <AKNLISTS.H>
#endif

#if !defined(__EIKMOBS_H__)
#include <EIKMOBS.H>
#endif

#if !defined(__AKNEDSTSOBS_H__)
#include <AKNEDSTSOBS.H>
#endif

// Forward declarations
class CSKKm;
class CAknEdwinState;
class CSKKmKanaEngine;
class CAknNavigationControlContainer;
class CAknNavigationDecorator;
class CFepIndicator;


class CSKKmControl : public CCoeControl, private MFepInlineTextFormatRetriever, MFepPointerEventHandlerDuringInlineEdit
{
 private:
    //constructor
    CSKKmControl(CSKKm& aFep);
    void ConstructL();
 public:
    static CSKKmControl* NewL(CSKKm& aFep);
    ~CSKKmControl();
		
    //From CCoeControl
    TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);

    // from MFepInlineTextFormatRetriever
    virtual void GetFormatOfFepInlineText(TCharFormat& aFormat, TInt& aNumberOfCharactersWithSameFormat, TInt aPositionOfCharacter) const;

    // from MFepPointerEventHandlerDuringInlineEdit
    virtual void HandlePointerEventInInlineTextL(TPointerEvent::TType aType, TUint aModifiers, TInt aPositionInInlineText);
        
 public:	// New methods
    TKeyResponse OfferKeyEventInKanaModeL(const TKeyEvent& aKeyEvent);
    TKeyResponse OfferKeyEventInAlphaModeL(const TKeyEvent& aKeyEvent);
    TKeyResponse OfferKeyEventInNumericModeL(const TKeyEvent& aKeyEvent, TEventCode aType);
    TKeyResponse OfferKeyEventInSecretAlphaModeL(const TKeyEvent& aKeyEvent, TEventCode aType);

    void HandleKanaModeKeyCodeL(TUint aKeyCode);

    void SimulateKeyEventL(TUint aCharacter);

    void HandleChangeInFocus();
    void HandleChangeInFocusL();
		
    // Start of inline text editing
    void StartInlineEditL(MCoeFepAwareTextEditor& aFepAwareTextEditor, const TDesC& aInitialInlineText, 
			  TInt aPositionOfInsertionPointInInlineText, TBool aCursorVisibility);
		
    void CancelInlineEdit(MCoeFepAwareTextEditor& aFepAwareTextEditor);
    void UpdateInlineEditL(const TDesC& aNewInlineText, TInt aPositionOfInsertionPointInInlineText);
    void CommitInlineEditL(MCoeFepAwareTextEditor& aFepAwareTextEditor, TBool aCursorVisibility);

    void ClearBuffer(void);
    void ClearKakutei(void);

 public: // new methods
    void SwitchInputModeL(TUint aInputMode);	// For switching input mode 
    CAknEdwinState* EditorState() const;		// Get current Avkon eidtor state

 private:
    void enter_kana_mode(void);
    void set_local_capabilities(void);
#ifdef DEBUG
    void print_capabilities(void);
#endif DEBUG

 private:
    CSKKm&			iFep;
    TCoeInputCapabilities	iInputCapabilities;
    TUint			iInputMode;
    TInt			iInsideInlineEditingTransaction; // Flag for editor inline editing 

    CSKKmKanaEngine*		iKanaEngine;

    CFepIndicator*		iIndicator;
	
    //    TInt			iResId;	// For containing the T9 resource ID
    TUint kana_mode;
    TUint abbrev_mode;
    TUint capabilities;
};
