#ifndef FEPINDICATOR_H
#define FEPINDICATOR_H

#include <e32base.h>

class CAknNavigationDecorator;
class CAknNavigationControlContainer;
class CEikonEnv;
class CAknIndicatorContainer;

class CFepIndicator : public CBase
    {
	public:
		enum TIndicatorState
			{
			EStateNone = 1,
			EStateAlpha,
			EStateKana,
			EStateKatakana,
			EStateHankaku,
			EStateLabel
			};

	public:
		static CFepIndicator* NewL();
		~CFepIndicator();
		virtual void SetState(TIndicatorState aState);
		void set_label(TDesC&);

	private:
		CFepIndicator();
		void AddContainerL(CAknNavigationControlContainer* aNaviPane);
		void RemoveContainer();
		CAknNavigationControlContainer* NaviPaneL();

	private:
		CAknIndicatorContainer*     iIndicatorContainer;
		CAknNavigationDecorator*    iNaviDecorator;
		TIndicatorState			iPreviousState;
		CEikonEnv&			iEikEnv;
		CAknNavigationControlContainer* iNaviPane;
		TBool				iNaviPaneChanged;
		TBuf<2048>			state_label;
    };

#endif // FEPINDICATOR_H

// End of file
