#include <eikappui.h>
#include <eikenv.h>

#include <FEPBASE.H>
#include <w32std.h> 
#include <bautils.h>
#include <frmtlay.h>

#include <aknedsts.h> 
#include "skkm.h"
#include "fepcontrol.h"

/**
 * Main Fep construction - defined in COEFEPU.DEF
 */
EXPORT_C CCoeFep* NewFepL(CCoeEnv& aConeEnvironment, const TDesC& /*aFullFileNameOfDll*/, const CCoeFepParameters& aFepParameters)
    {
	CSKKm* const fep = new(ELeave) CSKKm(aConeEnvironment);
    CleanupStack::PushL(fep);
    fep->ConstructL(aFepParameters);
    CleanupStack::Pop(); // fep

    return fep;
    }

/**
 * Export defined in COEFEPU.DEF - unused
 */

EXPORT_C void SynchronouslyExecuteSettingsDialogL(CCoeEnv& /*aConeEnvironment*/, const TDesC& /*aFullFileNameOfDll*/)
    {
	}

/**
 * Reserved exports defined in COEFEPU.DEF - unused
 */
EXPORT_C void Reserved_1(){}
EXPORT_C void Reserved_2(){}
EXPORT_C void Reserved_3(){}
EXPORT_C void Reserved_4(){}
EXPORT_C void Reserved_5(){}
EXPORT_C void Reserved_6(){}
EXPORT_C void Reserved_7(){}
EXPORT_C void Reserved_8(){}


GLDEF_C TInt E32Dll(TDllReason)
	{
    return KErrNone;
    }


/////////////////////////////////////////////////////////////////////////////////
//
//Class CSKKm
//
/////////////////////////////////////////////////////////////////////////////////

CSKKm::CSKKm(CCoeEnv& aConeEnvironment)
	:CCoeFep(aConeEnvironment)
	{	
	}

void CSKKm::ConstructL(const CCoeFepParameters& aFepParameters)
	{
	BaseConstructL(aFepParameters);
	iFepControl = CSKKmControl::NewL(*this);
	}

CSKKm::~CSKKm()
    {
    if (iFepControl!=NULL)
        delete iFepControl;
    }


TInt CSKKm::NumberOfAttributes() const 
	{
	return 0;
	}

TUid CSKKm::AttributeAtIndex(TInt /*aIndex*/) const 
	{
	return KNullUid;
	}

void CSKKm::WriteAttributeDataToStreamL(TUid /*aAttributeUid*/, RWriteStream& /*aStream*/) const 
	{
	}

void CSKKm::ReadAttributeDataFromStreamL(TUid /*aAttributeUid*/, RReadStream& /*aStream*/) 
	{
	}

void CSKKm::OfferKeyEventL(TEventResponse& /*aEventResponse*/,const TKeyEvent& /*aKeyEvent*/, TEventCode /*aEventCode*/)
	{
	}

void CSKKm::OfferPointerEventL(TEventResponse& /*aEventResponse*/,const TPointerEvent& /*aPointerEvent*/, const CCoeControl* /*aWindowOwningControl*/)
	{
	}

void CSKKm::OfferPointerBufferReadyEventL(TEventResponse& /*aEventResponse*/, const CCoeControl* /*aWindowOwningControl*/)//wbase
	{
	}

void CSKKm::HandleChangeInFocus()
    {
	if (iFepControl)
		{
		iFepControl->HandleChangeInFocus();
		}
	}

void CSKKm::HandleDestructionOfFocusedItem()
	{
	}

void CSKKm::HandleGainingForeground()
    {
    }

void CSKKm::HandleLosingForeground()
    {
    }

void CSKKm::CancelTransaction()
	{
	}

void CSKKm::IsOnHasChangedState()
	{
	}

// end of file
